function vexpower.panel_text()
	local tagvalues = {
		["PowerCurrent"] = "PowerCurrent",
		["PowerCurrentShort"] = "PowerCurrentShort",
		["PowerCurrentSmart"] = "PowerCurrentSmart",
		["PowerMax"] = "PowerMax",
		["PowerMaxShort"] = "PowerMaxShort",
		["PowerMaxSmart"] = "PowerMaxSmart",
		["PowerMissing"] = "PowerMissing",
		["PowerMissingShort"] = "PowerMissingShort",
		["PowerMissingSmart"] = "PowerMissingSmart",
		["PowerPerc"] = "PowerPerc",
		["PowerPercSmart"] = "PowerPercSmart",
		["CPsCurrent"] = "CPsCurrent",
		["CPsMax"] = "CPsMax",
		["CPsMissing"] = "CPsMissing",
		}

	return {
		type = "group",
		order= 3,
		args = {
			grpinfo = {
				name = "Tags to parse information in the text",
				order=1, type ="group", dialogInline = true,
				args = {
					energy2 = {name = "Current Power:\n|CFFFF7D0A[PowerCurrent]|r: Shows '19218' (current power)\n|CFFFF7D0A[PowerCurrentShort]|r: Shows '19' instead of '19218' (current power)\n|CFFFF7D0A[PowerCurrentSmart]|r: Shows '19.2' instead of '19218' (current power)", type="description", fontSize="medium", order=2},
					energy3 = {name = "Maximum Power:\n|CFFFF7D0A[PowerMax]|r: Shows '19218' (maximum power)\n|CFFFF7D0A[PowerMaxShort]|r: Shows '19' instead of '19218' (maximum power)\n|CFFFF7D0A[PowerMaxSmart]|r: Shows '19.2' instead of '19218' (maximum power)", type="description", fontSize="medium", order=3},
					energy4 = {name = "Missing Power:\n|CFFFF7D0A[PowerMissing]|r: Shows '19218' (missing power)\n|CFFFF7D0A[PowerMissingShort]|r: Shows '19' instead of '19218' (missing power)\n|CFFFF7D0A[PowerMissingSmart]|r: Shows '19.2' instead of '19218' (missing power)", type="description", fontSize="medium", order=4},
					energy5 = {name = "Percentage Power:\n|CFFFF7D0A[PowerPerc]|r: Shows '18' for 18.3%\n|CFFFF7D0A[PowerPercSmart]|r: Shows '18.3' for 18.3%", type="description", fontSize="medium", order=5},
					cps1 = {name = "ComboPoints:", type="description", fontSize="medium", order=11},
					cps2 = {name = "|CFFFF7D0A[CPsCurrent]|r: Shows your current combopoints/holypower/etc\n|CFFFF7D0A[CPsMax]|r: Shows your maximum combopoints/holypower/etc\n|CFFFF7D0A[CPsMissing]|r: Shows your missing combopoints/holypower/etc", type="description", fontSize="medium", order=12},
					}
				},
			frame_space1 = {name ="\n", type = "description", order=2},
			grpleft = {
				name = "Left text",
				order=3, type ="group", dialogInline = true,
				args = {
					framelefttextcontent = {
						name = "Text",
						desc = "Text that is shown left",
						order=1, type = "input", multiline = false,
						width = "double",
						set = function(info,val) vexpower_parameters["frame"]["energy"]["text"]["left"]["text"]=val vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["text"]["left"]["text"] end
						},
					frameleftinserttag = {
						name = "Insert Tag",
						order=2, type = "select", style = "dropdown",
						values = tagvalues,
						set = function(self,key) vexpower_panel_TagInsert("left", key) vexpower_initialize(true) end,
						get = function() return "" end,
						},
					framelefttexttags = {name = " ", type="description", order=3},
					framelefttextfont = {
						name = "Font",
						order=5, type = "select",
						dialogControl = "LSM30_Font",
						values = vexpower.LSM:HashTable("font"),
						set = function(self,key) vexpower_parameters["frame"]["energy"]["text"]["left"]["font"]=key vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["text"]["left"]["font"] end,
						},
					framelefttextsize = {
						name = "Size",
						order=6, type = "range",
						step = 1, min = 6, max = 20,
						set = function(info,val) vexpower_parameters["frame"]["energy"]["text"]["left"]["size"]=val vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["text"]["left"]["size"] end,
						},
					framelefttextfontalign = {
						name = "Text align",
						order=7, type = "select", style = "dropdown",
						desc = "Sets the text align",
						values = {["LEFT"]="Left", ["CENTER"]="Center", ["RIGHT"]="Right"},
						set = function(self,key) vexpower_parameters["frame"]["energy"]["text"]["left"]["align"]=key vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["text"]["left"]["align"] end,
						},
					framelefttextcolor = {
						name = "color",
						order=8, type = "color", hasAlpha=true, width="double",
						desc = "Sets the text color",
						set = function(info,r,g,b,a)
							vexpower_parameters["frame"]["energy"]["text"]["left"]["color"]["r"]=r
							vexpower_parameters["frame"]["energy"]["text"]["left"]["color"]["g"]=g
							vexpower_parameters["frame"]["energy"]["text"]["left"]["color"]["b"]=b
							vexpower_parameters["frame"]["energy"]["text"]["left"]["color"]["a"]=a
							vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["text"]["left"]["color"]["r"],
							vexpower_parameters["frame"]["energy"]["text"]["left"]["color"]["g"],
							vexpower_parameters["frame"]["energy"]["text"]["left"]["color"]["b"],
							vexpower_parameters["frame"]["energy"]["text"]["left"]["color"]["a"] end,
						},
					framelefteffect = {
						name = "effect",
						order=9, type = "select", style = "dropdown",
						values = {["MONOCHROME"]="Monochrome",
									["OUTLINE"]="Outline",
									[""]="None",
									["THICKOUTLINE"]="Thickoutline"},
						set = function(self,key) vexpower_parameters["frame"]["energy"]["text"]["left"]["effect"]=key vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["text"]["left"]["effect"] end,
						},
					framelefttextwidth = {
						name = "Width",
						order=10, type = "range",
						step = 1, min = 1, max = 400,
						set = function(info,val) vexpower_parameters["frame"]["energy"]["text"]["left"]["width"]=val vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["text"]["left"]["width"] end
						},
					framelefttextx = {
						name = "X Position",
						order=11, type = "range",
						step = 1, min = -100, max = 100,
						set = function(info,val) vexpower_parameters["frame"]["energy"]["text"]["left"]["x"]=val vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["text"]["left"]["x"] end
						},
					framelefttexty = {
						name = "Y Position",
						order=12, type = "range",
						step = 1, min = -100, max = 100,
						set = function(info,val) vexpower_parameters["frame"]["energy"]["text"]["left"]["y"]=val vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["text"]["left"]["y"] end
						},
					grpleftshadow = {
						name = "Shadow Effect",
						order=20, type ="group", dialogInline = true,
						args = {
							leftshadowallow = {
								name = "Activate shadow effect",
								order=1, type = "toggle", width="full",
								desc = "",
								set = function(self,key) vexpower_parameters["frame"]["energy"]["text"]["left"]["shadow"]["allow"]=key vexpower_initialize(true) end,
								get = function() return vexpower_parameters["frame"]["energy"]["text"]["left"]["shadow"]["allow"] end,
								},
							leftshadowcolor = {
								name = "color",
								disabled = not(vexpower_parameters["frame"]["energy"]["text"]["left"]["shadow"]["allow"]),
								order=2, type = "color", hasAlpha=true, width="double",
								set = function(info,r,g,b,a)
									vexpower_parameters["frame"]["energy"]["text"]["left"]["shadow"]["color"]["r"]=r
									vexpower_parameters["frame"]["energy"]["text"]["left"]["shadow"]["color"]["g"]=g
									vexpower_parameters["frame"]["energy"]["text"]["left"]["shadow"]["color"]["b"]=b
									vexpower_parameters["frame"]["energy"]["text"]["left"]["shadow"]["color"]["a"]=a
									vexpower_initialize(true) end,
								get = function() return vexpower_parameters["frame"]["energy"]["text"]["left"]["shadow"]["color"]["r"],
									vexpower_parameters["frame"]["energy"]["text"]["left"]["shadow"]["color"]["g"],
									vexpower_parameters["frame"]["energy"]["text"]["left"]["shadow"]["color"]["b"],
									vexpower_parameters["frame"]["energy"]["text"]["left"]["shadow"]["color"]["a"] end,
								},
							leftshadowopacity = {
								name = "Opacity %",
								order=3, type = "range",
								step = 5, min = 0, max = 100,
								disabled = not(vexpower_parameters["frame"]["energy"]["text"]["left"]["shadow"]["allow"]),
								set = function(info,val) vexpower_parameters["frame"]["energy"]["text"]["left"]["shadow"]["color"]["a"]=val/100 vexpower_initialize(true) end,
								get = function() return vexpower_parameters["frame"]["energy"]["text"]["left"]["shadow"]["color"]["a"]*100 end
								},
							leftshadowx = {
								name = "X Position",
								order=4, type = "range",
								step = 1, min = -50, max = 50,
								disabled = not(vexpower_parameters["frame"]["energy"]["text"]["left"]["shadow"]["allow"]),
								set = function(info,val) vexpower_parameters["frame"]["energy"]["text"]["left"]["shadow"]["offset"]["x"]=val vexpower_initialize(true) end,
								get = function() return vexpower_parameters["frame"]["energy"]["text"]["left"]["shadow"]["offset"]["x"] end
								},
							leftshadowy = {
								name = "Y Position",
								order=5, type = "range",
								step = 1, min = -50, max = 50,
								disabled = not(vexpower_parameters["frame"]["energy"]["text"]["left"]["shadow"]["allow"]),
								set = function(info,val) vexpower_parameters["frame"]["energy"]["text"]["left"]["shadow"]["offset"]["y"]=val vexpower_initialize(true) end,
								get = function() return vexpower_parameters["frame"]["energy"]["text"]["left"]["shadow"]["offset"]["y"] end
								},
							},
						},
						
					},
				},
			frame_space2 = {name ="\n", type = "description", order=4},
			
			
			grpright = {
				name = "Right text",
				order=5, type ="group", dialogInline = true,
				args = {
					framerighttextcontent = {
						name = "text",
						desc = "text that is shown right",
						order=100, type = "input", multiline = false,
						width = "double",
						set = function(info,val) vexpower_parameters["frame"]["energy"]["text"]["right"]["text"]=val vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["text"]["right"]["text"] end
						},
					framerightinserttag = {
						name = "Insert Tag",
						order=101, type = "select", style = "dropdown",
						values = tagvalues,
						set = function(self,key) vexpower_panel_TagInsert("right", key) vexpower_initialize(true) end,
						get = function() return "" end,
						},
					framerighttexttags = {name = " ", type="description", order=103},
					framerighttextfont = {
						name = "font",
						order=105, type = "select",
						dialogControl = "LSM30_Font",
						values = vexpower.LSM:HashTable("font"),
						set = function(self,key) vexpower_parameters["frame"]["energy"]["text"]["right"]["font"]=key vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["text"]["right"]["font"] end,
						},
					framerighttextsize = {
						name = "Size",
						order=106, type = "range",
						step = 1, min = 6, max = 20,
						set = function(info,val) vexpower_parameters["frame"]["energy"]["text"]["right"]["size"]=val vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["text"]["right"]["size"] end,
						},
					framerighttextfontalign = {
						name = "Text align",
						order=107, type = "select", style = "dropdown",
						desc = "Sets the text align",
						values = {["LEFT"]="Left", ["CENTER"]="Center", ["RIGHT"]="Right"},
						set = function(self,key) vexpower_parameters["frame"]["energy"]["text"]["right"]["align"]=key vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["text"]["right"]["align"] end,
						},
					framerighttextcolor = {
						name = "color",
						order=108, type = "color", hasAlpha=true, width="double",
						set = function(info,r,g,b,a)
							vexpower_parameters["frame"]["energy"]["text"]["right"]["color"]["r"]=r
							vexpower_parameters["frame"]["energy"]["text"]["right"]["color"]["g"]=g
							vexpower_parameters["frame"]["energy"]["text"]["right"]["color"]["b"]=b
							vexpower_parameters["frame"]["energy"]["text"]["right"]["color"]["a"]=a
							vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["text"]["right"]["color"]["r"],
							vexpower_parameters["frame"]["energy"]["text"]["right"]["color"]["g"],
							vexpower_parameters["frame"]["energy"]["text"]["right"]["color"]["b"],
							vexpower_parameters["frame"]["energy"]["text"]["right"]["color"]["a"] end,
						},
					framerighteffect = {
						name = "effect",
						order=109, type = "select", style = "dropdown",
						values = {["MONOCHROME"]="Monochrome",
									["OUTLINE"]="Outline",
									[""]="None",
									["THICKOUTLINE"]="Thickoutline"},
						set = function(self,key) vexpower_parameters["frame"]["energy"]["text"]["right"]["effect"]=key vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["text"]["right"]["effect"] end,
						},
					framerighttextwidth = {
						name = "Width",
						order=110, type = "range",
						step = 1, min = 1, max = 400,
						set = function(info,val) vexpower_parameters["frame"]["energy"]["text"]["right"]["width"]=val vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["text"]["right"]["width"] end
						},
					framerighttextx = {
						name = "X-Position",
						order=111, type = "range",
						step = 1, min = -100, max = 100,
						set = function(info,val) vexpower_parameters["frame"]["energy"]["text"]["right"]["x"]=val vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["text"]["right"]["x"] end
						},
					framerighttexty = {
						name = "Y-Position",
						order=112, type = "range",
						step = 1, min = -100, max = 100,
						set = function(info,val) vexpower_parameters["frame"]["energy"]["text"]["right"]["y"]=val vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["text"]["right"]["y"] end
						},
					grprightshadow = {
						name = "Shadow Effect",
						order=120, type ="group", dialogInline = true,
						args = {
							rightshadowallow = {
								name = "Activate shadow effect",
								order=1, type = "toggle", width="full",
								desc = "",
								set = function(self,key) vexpower_parameters["frame"]["energy"]["text"]["right"]["shadow"]["allow"]=key vexpower_initialize(true) end,
								get = function() return vexpower_parameters["frame"]["energy"]["text"]["right"]["shadow"]["allow"] end,
								},
							rightshadowcolor = {
								name = "color",
								order=2, type = "color", hasAlpha=true, width="double",
								disabled = not(vexpower_parameters["frame"]["energy"]["text"]["right"]["shadow"]["allow"]),
								set = function(info,r,g,b,a)
									vexpower_parameters["frame"]["energy"]["text"]["right"]["shadow"]["color"]["r"]=r
									vexpower_parameters["frame"]["energy"]["text"]["right"]["shadow"]["color"]["g"]=g
									vexpower_parameters["frame"]["energy"]["text"]["right"]["shadow"]["color"]["b"]=b
									vexpower_parameters["frame"]["energy"]["text"]["right"]["shadow"]["color"]["a"]=a
									vexpower_initialize(true) end,
								get = function() return vexpower_parameters["frame"]["energy"]["text"]["right"]["shadow"]["color"]["r"],
									vexpower_parameters["frame"]["energy"]["text"]["right"]["shadow"]["color"]["g"],
									vexpower_parameters["frame"]["energy"]["text"]["right"]["shadow"]["color"]["b"],
									vexpower_parameters["frame"]["energy"]["text"]["right"]["shadow"]["color"]["a"] end,
								},
							rightshadowopacity = {
								name = "Opacity %",
								order=3, type = "range",
								step = 5, min = 0, max = 100,
								disabled = not(vexpower_parameters["frame"]["energy"]["text"]["right"]["shadow"]["allow"]),
								set = function(info,val) vexpower_parameters["frame"]["energy"]["text"]["right"]["shadow"]["color"]["a"]=val/100 vexpower_initialize(true) end,
								get = function() return vexpower_parameters["frame"]["energy"]["text"]["right"]["shadow"]["color"]["a"]*100 end
								},
							rightshadowx = {
								name = "X Position",
								order=4, type = "range",
								step = 1, min = -50, max = 50,
								disabled = not(vexpower_parameters["frame"]["energy"]["text"]["right"]["shadow"]["allow"]),
								set = function(info,val) vexpower_parameters["frame"]["energy"]["text"]["right"]["shadow"]["offset"]["x"]=val vexpower_initialize(true) end,
								get = function() return vexpower_parameters["frame"]["energy"]["text"]["right"]["shadow"]["offset"]["x"] end
								},
							rightshadowy = {
								name = "Y Position",
								order=5, type = "range",
								step = 1, min = -50, max = 50,
								disabled = not(vexpower_parameters["frame"]["energy"]["text"]["right"]["shadow"]["allow"]),
								set = function(info,val) vexpower_parameters["frame"]["energy"]["text"]["right"]["shadow"]["offset"]["y"]=val vexpower_initialize(true) end,
								get = function() return vexpower_parameters["frame"]["energy"]["text"]["right"]["shadow"]["offset"]["y"] end
								},
							},
						},
					},
				},
			}
		}
end

function vexpower_panel_TagInsert(text, tag)
	if text == "left" then
		vexpower_parameters["frame"]["energy"]["text"]["left"]["text"] = vexpower_parameters["frame"]["energy"]["text"]["left"]["text"].."["..tag.."]"
	else
		vexpower_parameters["frame"]["energy"]["text"]["right"]["text"] = vexpower_parameters["frame"]["energy"]["text"]["right"]["text"].."["..tag.."]"
	end
end